  #include <EEPROM.h>
  byte incomingByte;
  byte note;
  byte velocity;
  int noteDown = LOW;
  int state=0;  // state machine variable 0 = command waiting : 1 = note waitin : 2 = velocity waiting
  int baseNote = 60;  // lowest note
  // use different values of baseNote to select the MIDI octiave
  // 24 for octiave 1 -- 36 for octiave 2 -- 48 for octiave 3 -- 60 for octiave 4 -- 72 for octiave 5
  // 84 for octiave 6 -- 96 for octiave 7
  

  byte playArray[] =    { 2,  0,  3,  0,  4,  5,  0,  6,  0,  7,  0,  8,  9, 0, 10, 0, 11, 12 }; //pins
// corresponding to note  60,     62,     64, 65,     67,     69,     71, 72,   74,    76, 77 
int strobe = 13;   // select the pin for the monostable
byte channel;
int address = 1; // mem channel
const byte sel = 14; //A0
const byte cled = 15; //A1
boolean schn = 1; //switch state


//setup: declaring iputs and outputs and begin serial 
void setup() { 
  pinMode (sel, INPUT_PULLUP); // btn select chn
  pinMode(strobe,OUTPUT);   // declare the strobe pin as output
  pinMode(2,OUTPUT);
  pinMode(3,OUTPUT);
  pinMode(4,OUTPUT);
  pinMode(5,OUTPUT);
  pinMode(6,OUTPUT);
  pinMode(7,OUTPUT);
  pinMode(8,OUTPUT);
  pinMode(9,OUTPUT);
  pinMode(10,OUTPUT);
  pinMode(11,OUTPUT);
  pinMode(12,OUTPUT);
  pinMode(cled,OUTPUT);
  state = 0;  // initilise state machine variable
  //start serial with MIDI baudrate 31250 or 38400 for debugging
  Serial.begin(31250);        
  digitalWrite(strobe,LOW); 

  channel = EEPROM.read(address);
  delay (100);
if (channel < 0 || channel > 15)
{
channel = 0;
EEPROM.write(address, channel);
delay(1000);
start (channel);
}
else
{
delay(1000);
bar (channel);
}	  
}


void loop () {
  boolean schn = digitalRead(sel); // btn channnel select
  if (schn == HIGH) // on(off) // LOW off(on)
      {
      channel+=1;
      
      if (channel <= 15)
      {
      EEPROM.write(address, channel);
      delay(500);
      bar (channel);
      }
      if (channel >= 16)
      {
      channel = 0;
    EEPROM.write(address, channel);
      delay(500);
      bar(channel);
      }
      }

  if (Serial.available() > 0) {
	  
    // read the incoming byte:
    incomingByte = Serial.read();
     digitalWrite(strobe,LOW);    // clear any previous strobe
	  
   switch (state){
      case 0:
    // look for as status-byte, our channel, note on
    if (incomingByte== (144 | channel)){ 
         noteDown = HIGH;
         state=1;
        }
    // look for as status-byte, our channel, note off
    if (incomingByte== (128 | channel)){ 
         noteDown = LOW;
         state=1;
        }
        
       case 1:
       // get the note to play or stop
       if(incomingByte < 128) {
          note=incomingByte;
          state=2;
       }
       else{
       state = 0;  // reset state machine as this should be a note number
       }
       break;
       
       case 2:
       // get the velocity
       if(incomingByte < 128) {
         playNote(note, incomingByte, noteDown); // fire off the solenoid
       }
         state = 0;  // reset state machine to start            
     }
  }
}

void playNote(byte note, byte velocity, int down){
  // if velocity = 0 on a 'Note ON' command, treat it as a note off
  if ((down == HIGH) && (velocity == 0)){
      down = LOW; 
  }
 //since we can't play all notes we only action notes between 60 & 78
 if(note>=baseNote && note<(baseNote + 18)) //changer ce numéro si pin SUP ou MOINS
     {
   byte myPin=playArray[note-baseNote]; // to get a pin number between 2 and 12 //ex: note77 - baseNote = array 17 = pin12
   if(myPin != 0) {
     digitalWrite(myPin, down); // play it if it is one of our notes
     if(down == HIGH) digitalWrite(strobe, HIGH); // strobe high to monostable for note on
   }
 } 

}
void start(byte channel)
{
    for (byte i=0; i<channel+1; i++) 
    {
    digitalWrite(cled, HIGH);
    delay(50);
    digitalWrite(cled, LOW);
    delay(400);
    loop();
    }
}
void bar(byte channel)
{
    for (byte i=0; i<channel+1; i++) 
    {
    digitalWrite(cled, HIGH);
    delay(50);
    digitalWrite(cled, LOW);
    delay(400);
    }
}
